// gcc my-trsv.c -o trsm.x -Wall -L/Users/pauldj/works/libs/OpenBLAS-develop/ -lopenblas 
// gcc my-trsv.c -o trsm.x -Wall -L/opt/local/lib -lopenblas 


#include <stdlib.h>
#include <stdio.h> 

void dtrsv_( char *, char *, char *, int *, double *, int *, double *, int * );



int main( int argc, char *argv[] )
{
  int n, i, j;
  double *L, *y;
   
  if(argc == 1){ printf(" argument needed: pass me one argument\n"); return(-1);}
  if(argc > 1)  n = atoi(argv[1]);

  L = (double *) malloc( n * n * sizeof(double) );
  y = (double *) malloc( n * sizeof(double) );

  /*       j 
   1 0 0 0 0   ...
   2 3 0 0 0   ...
   5 6 7 0 0 
   . . . . 0 
i  . . . . i^2 + j + 1    
   */

  for( i=0; i<n; i++ )     //row
     for( j=0; j<n; j++ )        //column   
	if( j <= i ){
           //           printf(" idx(%d,%d) -> L(%d) = %d\n", i, j, i + j*n, i*i + j + 1);
           L[ j*n + i ] = i*i + j + 1;
        }
	else
	   L[ j*n + i ] = 0;


  for( i=0; i<n; i++ ) y[ i ] = 1; 


  FILE *output;
  output = fopen("mfile.m", "w");
  //output = stdout;

  fprintf(output, "L = [ ...\n" );
  for( i=0; i<n; i++ ) //row
    {
      for( j=0; j<n; j++ )  //column
	fprintf(output, "%g ", L[j*n+i] );
      fprintf(output, "; ...\n" );
    }
  fprintf(output, "];\n" );


  fprintf(output, "y = [ ...\n" );
  for( j=0; j<n; j++ )  
    fprintf(output, "%g; ...\n ", y[j] );
  fprintf(output, "];\n" );
  
  char uplo = 'L';
  char trans = 'N';
  int incy = 1;

  dtrsv_( &uplo, &trans, "N", &n, L, &n, y, &incy );

  
  fprintf(output, "x = [ ...\n" );
  for( j=0; j<n; j++ )  
    fprintf(output, "%.16g; ...\n ", y[j] );
  fprintf(output, "];\n" );

  // check the results! Are they correct? 

  fprintf(output, "format long\n ");
  fprintf(output, "norm(x - L\\y)\n ");
  
  free( L );
  free( y );

  return( 0 );
}

