/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc test10.c  -o test.x -Wall 

// #10
// dynamic memory allocation
// definition of arrays (matrices, vectors... )


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary
#include <math.h>     // pow

int printvector( double *vector, char *name, int n );


int main(int argc, char *argv[] )
{
   int i, n;
   
   if(argc == 1) 
     {
       printf(" argument needed: pass me an integer\n");
       return( -1 );
     }
   else  
      n = atoi(argv[1]);
   
   double * M;  // M will be our vector


   // malloc allocates a block of contiguous memory
   M = (double *) malloc( n * sizeof(double) );
   // the unit of malloc and sizeof is the byte

   /*
   if(M == NULL) {
      fprintf(stderr, 
	      "Not enough memory to allocate %ld bytes.", 
	      n * sizeof(double)
	      );
      return( 1 );
   }
   */
   
   printvector( M, "vecInit", n ); 


   
   for( i=0; i<n; i++ )   M[i] = sqrt(i);   
   printvector( M, "vecSqrt", n );    
   printvector( M, "vecSqrt+2", n+2 ); 

   for( i=0; i<n; i++ )   M[i] = pow(M[i],2);
   printvector( M, "vecPow", n ); 

   
   // once I am done using M, I should release the memory
   free( M );   
   
   return( 0 );
}




int printvector( double* vector, char *name, int n )
{
   int i;

   printf(" %s = [", name );
   for( i=0; i<n; i++ ) printf("%.16lf ", vector[i] );
   printf("];\n");

   return( 0 );
}


